

#include "debug.h"
#include "string.h"

#define I2CPORT     GPIOB   //定义IO 组 接口
#define I2C_SCL     GPIO_Pin_8  //定义IO接口
#define I2C_SDA     GPIO_Pin_9  //定义IO接口

#define TxAdderss   0x02
#define Size   6

volatile uint16_t master_sate = 0;
volatile u8 mastr_RxData[Size] = { 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 };
volatile uint16_t master_recv_len = 0;

void I2C1_EV_IRQHandler(void) __attribute__((interrupt("WCH-Interrupt-fast")));
void I2C1_EV_IRQHandler(void )
{
    if( I2C_GetITStatus( I2C1, I2C_IT_SB ) != RESET )//起始位发送标志位
      {
          I2C_Send7bitAddress( I2C1, 0x02, I2C_Direction_Receiver );//置主机为接收状态
          ((void)(I2C1->STAR1));
          ((void)(I2C1->STAR2));
      }

    if( I2C_GetITStatus( I2C1, I2C_IT_ADDR ) != RESET )//地址匹配
    {
        ((void)(I2C1->STAR1));
        ((void)(I2C1->STAR2));
    }
     if( I2C_GetITStatus( I2C1, I2C_IT_BTF ) != RESET )
       {
           I2C_ReadRegister( I2C1, I2C_Register_STAR1);
           ((void)I2C1->DATAR);
       }
    if( I2C_GetITStatus( I2C1, I2C_IT_RXNE ) != RESET )
       {
               if(master_recv_len<6){
                   mastr_RxData[master_recv_len] = I2C1->DATAR;
                   master_recv_len++;
               }
               if (master_recv_len==5) {//发六个数据要在第五位时就要发停止位，也就是需要提前停止
                                  I2C_GenerateSTOP( I2C1, ENABLE );   //产生停止条件
                                  I2C_NACKPositionConfig(I2C1, I2C_NACKPosition_Next);
                                                  }
               if(master_recv_len==6){
                   master_sate=0xff;
            }
          ((void)(I2C1->STAR1));
          ((void)(I2C1->STAR2));
       }
}

void IIC_Init(u32 bound, u16 address) {
    GPIO_InitTypeDef GPIO_InitStructure = { 0 };
    I2C_InitTypeDef I2C_InitTSturcture = { 0 };

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOB | RCC_APB2Periph_AFIO, ENABLE);
    GPIO_PinRemapConfig(GPIO_Remap_I2C1, ENABLE);
    RCC_APB1PeriphClockCmd( RCC_APB1Periph_I2C1, ENABLE);

    GPIO_InitStructure.GPIO_Pin = I2C_SCL | I2C_SDA;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_OD;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(I2CPORT, &GPIO_InitStructure);

    I2C_InitTSturcture.I2C_ClockSpeed = bound;
    I2C_InitTSturcture.I2C_Mode = I2C_Mode_I2C;
    I2C_InitTSturcture.I2C_DutyCycle = I2C_DutyCycle_16_9;
    I2C_InitTSturcture.I2C_OwnAddress1 = address;
    I2C_InitTSturcture.I2C_Ack = I2C_Ack_Enable;
    I2C_InitTSturcture.I2C_AcknowledgedAddress = I2C_AcknowledgedAddress_7bit;
    I2C_Init( I2C1, &I2C_InitTSturcture);
    I2C_Cmd( I2C1, ENABLE);
    I2C_AcknowledgeConfig( I2C1, ENABLE);  //主机专用    启用或禁用指定的I2C确认特性。

    NVIC_InitTypeDef NVIC_InitStructure;  //  中断分组初始化
    NVIC_InitStructure.NVIC_IRQChannel = I2C1_EV_IRQn;  //中断
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;   //抢占优先级
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;  //子优先级
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    I2C_ITConfig( I2C1, I2C_IT_EVT, ENABLE);   //使能中断
}

int main(void) {
    Delay_Init();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n", SystemCoreClock);
    printf("IIC Host mode \r\n");
    IIC_Init(100000, TxAdderss);    //IIC波特率：80kHz,自身地址最后一位为0，进入主发送器模式

    while(1) {
        if(master_sate == 0xFF) {   //不能 在中断 中 清零   // 会多发出 一组  0位 数据
            master_sate = 0;
            master_recv_len = 0;
            printf( "  RxData : " );
            for(u8 i=0; i<6; i++ )
            {
                printf( "%02x ", mastr_RxData[i] );  //  "%02x " 后面 空的 是 空一格
            }
            printf( " \n" );
        }
        I2C_GenerateSTART(I2C1, ENABLE);  // 生成I2Cx通信START条件
        Delay_Ms(600);
    }
}